<?php /** @var Template_VariableAccessor $VAR */ ?>
<?php /** @var array $OPT */ ?>
<?php if (!$VAR->panel->isHttpsProxyEnabled || $VAR->server->webserver->proxyActive): ?>
    <?php return ?>
<?php endif ?>

<IfModule mod_ssl.c>
<?php for ($ipAddresses = $VAR->server->ipAddresses->all, $ipAddress = reset($ipAddresses); $ipAddress; $ipAddress = next($ipAddresses)): ?>
    <VirtualHost <?php
    echo "{$ipAddress->escapedAddress}:{$VAR->server->webserver->httpsPort}";
    for ($n = 1; $n < $OPT['ipLimit'] && $ipAddress = next($ipAddresses); $n++) {
        echo " {$ipAddress->escapedAddress}:{$VAR->server->webserver->httpsPort}";
    }
    if ($VAR->server->webserver->proxyActive) {
        echo " 127.0.0.1:{$VAR->server->webserver->httpsPort}";
    }
    ?>>

    <?php $sslCertificate = $VAR->panel->sslCertificate ?>
    <?php if ($sslCertificate->ceFilePath): ?>
        SSLEngine on
        SSLVerifyClient none
        SSLCertificateFile "<?=$sslCertificate->ceFilePath?>"
        <?php if ($sslCertificate->caFilePath): ?>
            SSLCACertificateFile "<?=$sslCertificate->caFilePath?>"
        <?php endif ?>
    <?php endif ?>

    <?php if ($VAR->panel->accessDomainName): ?>
        ServerName <?=$VAR->quote($VAR->panel->accessDomainName)?>
    <?php else: ?>
        ServerName "default"
    <?php endif ?>

        UseCanonicalName Off
        LimitRequestBody 2147483647
        ProxyTimeout 600

        <IfModule mod_proxy_http.c>
            <Location />
                ProxyPass http://127.0.0.1:8880/
                ProxyPassReverse http://127.0.0.1:8880/
                ProxyPreserveHost On
                RequestHeader set "X-Forwarded-Proto" "https"
                Order allow,deny
                Allow from all
            </Location>
            <LocationMatch "^/(.+/)?(ws|websocket)(/.*)?$">
                ProxyPassMatch ws://127.0.0.1:8880/$1$2$3
                ProxyPreserveHost On
                RequestHeader set "X-Forwarded-Proto" "https"
                Order allow,deny
                Allow from all
            </LocationMatch>
        </IfModule>

    <?php if ($VAR->panel->isApacheModSecurityEnabled) { ?>
        <IfModule mod_security2.c>
            SecRuleEngine Off
        </IfModule>
    <?php } ?>

    </VirtualHost>
<?php endfor ?>
</IfModule>
